<!-- 
 * @Description: 人员管理
 * @Author: syy 
 * @Date: 2024-7-15
-->
<template>
  <div class="main-box">
    <div class="table-box">
      <ProTable ref="proTable" title="人员管理" :columns="columns" rowKey="personId" :request-api="userManagePersonnelApi.page">
        <!-- 表格 header 按钮 -->
        <template #tableHeader="scope">
          <s-button v-auth="userPerButtonCode.add" suffix="人员" @click="onOpen(FormOptEnum.ADD)" />
          <s-button
            v-auth="userPerButtonCode.delete"
            type="danger"
            :opt="FormOptEnum.DELETE"
            plain
            suffix="人员"
            :disabled="!scope.isSelected"
            @click="onDelete(scope.selectedListIds, '删除所选人员')"
          />
        </template>
        <!-- 表格操作栏 -->
        <template #operation="scope">
          <el-space>
            <s-button v-auth="userPerButtonCode.edit" link :opt="FormOptEnum.EDIT" @click="onOpen(FormOptEnum.EDIT, scope.row)" />
            <s-button v-auth="userPerButtonCode.delete" link :opt="FormOptEnum.DELETE" @click="onDelete([scope.row.personId], `删除人员`)" />
            <el-dropdown @command="handleCommand">
              <el-link type="primary" :underline="false" :icon="ArrowDown"> 更多 </el-link>
              <template #dropdown>
                <el-dropdown-menu>
                  <el-dropdown-item :command="command(scope.row, cmdEnum.AddFace)"
                    ><el-upload
                      ref="upload"
                      class="upload-demo"
                      action="/api/business/personApi/uploadFile"
                      :show-file-list="false"
                      :on-success="handleAvatarSuccess"
                      accept=".jpg, .jpeg, .png"
                      :headers="{
                        Authorization: `${TokenEnum.TOKEN_PREFIX} ${accessToken}`
                      }"
                    >
                      <template #trigger>
                        {{ cmdEnum.AddFace }}
                      </template>
                    </el-upload>
                  </el-dropdown-item>
                  <el-dropdown-item :command="command(scope.row, cmdEnum.UnderpantsUnBinding)">
                    {{ cmdEnum.UnderpantsUnBinding }}
                  </el-dropdown-item>
                </el-dropdown-menu>
              </template>
            </el-dropdown>
          </el-space>
        </template>
      </ProTable>
    </div>
    <!-- 人员新增/编辑表单 -->
    <Form ref="formRef"></Form>
    <!-- 预览头像 -->
    <el-dialog v-model="visible" title="查看头像" width="830px" :before-close="handleClose">
      <div style="display: flex; align-items: center; justify-content: center">
        <img style="max-width: 100%; max-height: 600px" class="detailpic" :src="faceUrl" alt="" />
      </div>
    </el-dialog>
  </div>
</template>
<script setup lang="tsx" name="SysUserPersonnel">
import { userManagePersonnelApi,userPerButtonCode,SysUserPersonnel } from "@/api";
import { getMajorList, getDepartmentList, getClassList } from "@/mixin";
import { useHandleData } from "@/hooks/useHandleData";
import { FormOptEnum } from "@/enums";
import Form from "./components/form/index.vue";
import { ArrowDown } from "@element-plus/icons-vue";
import { ColumnProps, ProTableInstance } from "@/components/ProTable/interface";
import { useUserStore } from "@/stores/modules";
import { TokenEnum } from "@/enums";
import type { UploadProps } from "element-plus";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const faceUrl = ref('');
const visible = ref(false); //是否显示人员表单
const proTable = ref<ProTableInstance>();
const userStore = useUserStore();
const { accessToken } = userStore;
const departmentOptions = ref<any>([])
const majorOptions = ref<any>([])
const classOptions = ref<any>([])
//监听depId/majorId变化
watch(
  () => [proTable.value!?.searchParam?.depId,proTable.value!?.searchParam?.majorId],
  async ([newDepId,newMajorId],[oldDepId,oldMajorId]) => {
    if(newDepId !== oldDepId){
      majorOptions.value =await getMajorList(newDepId)
      classOptions.value = [];
      proTable.value!.searchParam.majorId = "";
      proTable.value!.searchParam.personSetId = ""
    }
    if(newMajorId !== oldMajorId){
      classOptions.value = await getClassList(newMajorId)
    }
    
    
  } ,{ deep: true, immediate: false }
);
// 表格配置项
const columns: ColumnProps<SysUserPersonnel.SysUserPerInfo>[] = [
  { type: "selection", fixed: "left", width: 50 },
  {
    prop: "depId",
    label: "所属系部",
    enum: departmentOptions,
    fieldNames: { label: "name", value: "id" },
    search: {
      el: "select",
      span:1,
      props: {
        clearable: false,
        placeholder: "请选择系部",
      },
    },
    isShow: false
  },
  {
    prop: "majorId",
    label: "所属专业",
    enum: majorOptions,
    fieldNames: { label: "name", value: "id" },
    search: {
      el: "select",
      span:1,
      props: {
        clearable: false,
        placeholder: "请选择专业",
      },
    },
    isShow: false
  },
  {
    prop: "personSetId",
    label: "所属班级",
    enum: classOptions,
    fieldNames: { label: "personSetName", value: "personSetId" },
    search: {
      el: "select",
      span:1,
      props: {
        clearable: false,
        placeholder: "请选择所属班级",
      },
    },
    isShow: false
  },
  {
    prop: "faceUrl",
    label: "人脸",
    render: scope => {
      return (
        <img src={scope.row.faces.length > 0 ? scope.row.faces[0].faceUrl : ''} onClick={() => viewHeadImage(scope)} style='width:50px;height:50px;' alt=''/>
      );
    }
  },
  {
    prop: "name",
    label: "姓名"
  },
  {
    prop: "personId",
    label: "人员ID"
  },
  {
    prop: "phone",
    label: "手机号"
  },
  {
    prop: "personSetName",
    label: "所属班级",
  },
  { prop: "operation", label: "操作", width: 250, fixed: "right" }
];
const viewHeadImage = (scope: any) => {
  faceUrl.value = scope.row.faces[0].faceUrl;
  visible.value = true
  console.log(faceUrl);
};
const handleClose = () => {
  visible.value = false;
};


// 人员表单引用
const formRef = ref<InstanceType<typeof Form> | null>(null);

/**
 * 打开表单
 * @param opt  操作类型
 * @param record  记录
 */
function onOpen(opt: FormOptEnum, record: {} | SysUserPersonnel.SysUserPerInfo = {}) {
  formRef.value?.onOpen({ opt: opt, record: record, successful: RefreshTable });
}

/**
 * 人员删除
 * @param ids  id数组
 */
 async function onDelete(ids: string[], msg: string) {
  if(ids.length === 0){
    ElMessage({
      message: '请选择要删除的人员',
      type: 'warning'
    });
    return
  }
  // 二次确认 => 请求api => 刷新表格
  await useHandleData(userManagePersonnelApi.delete, {id: ids.join(",") }, msg);
  RefreshTable(); //刷新表格
}

// 刷新表格
const RefreshTable = () => {
  proTable.value?.refresh();
  // treeFilter.value?.refresh(); //刷新树形筛选器
}


/** 更多下拉菜单命令枚举 */
enum cmdEnum {
  AddFace = "添加人脸",
  UnderpantsUnBinding = "底库解绑"
}
/** 下拉菜单参数接口 */
interface Command {
  row: SysUserPersonnel.SysUserPerInfo;
  command: cmdEnum;
}

/**配置command的参数 */
function command(row: SysUserPersonnel.SysUserPerInfo, command: cmdEnum): Command {
  return {
    row: row,
    command: command
  };
}
/**
 * 列表更多下拉菜单点击事件
 * @param command
 */
const personId = ref<number | string>(); //人员id
function handleCommand(command: Command) {
  switch (command.command) {
    case cmdEnum.AddFace:
      personId.value = command.row.personId; //获取人员id
      break
    case cmdEnum.UnderpantsUnBinding:
      userManagePersonnelApi.personUnBindDfie({
        personId:command.row.personId,
        personSetId: command.row.personSetId
      }).then(res=>{
          ElMessage.success('底库解绑成功');
          RefreshTable()
      })
      break;
  }
}



const handleAvatarSuccess: UploadProps["onSuccess"] = (response) => {
  if (response.code === 200) {
    userManagePersonnelApi.addFace({
      personId: personId.value,
      faceUrl: response.data
    }).then(res=>{
      RefreshTable()
    })
  } else {
    ElMessage.error(response.msg);
  }
};
onMounted(async () => {
  // 获取系部下拉数据
  departmentOptions.value = await getDepartmentList()
  // 获取班级
  classOptions.value = await getClassList("");
});
</script>
<style scoped lang="scss">
.table-box {
  width: 100%;
  height: 100%;
}
.custom-tree-node {
  display: flex;
  flex: 1;
  align-items: center;
  justify-content: space-between;
  padding-right: 8px;
  font-size: 14px;
}
</style>
